/*
biblioteca para uso com o servidor do Houaiss Corporativo
*/

// cria namespace como funcao
var dhserver = (function() {
    var publico = {};
    // endereco absoluto do diretorio com arquivos (nao escrever protocolo. Informar apenas o diretorio. ex. 'www.meudominio.com.br/hserver')
    var dhserver_endereco = "houaiss.online/houaisson/apps/webserver/vopen/hserver_data";
    // padroes iniciais adotados no primeiro acesso e que podem ser escolhidas pelo usuario
    var dhserver_dicionario = "grande"; // indica o dicionario de conexao padrao (valor padrao inicial) - grande, sinant
    var dhserver_duplo_clique = "1"; // indica se a selecao de palavras por selecao esta ligada (valor padrao inicial) - 0: nao 1:sim
    var dhserver_alt_obrigatorio = "1"; // indica se o alt deve ser pressionado com a selecao (valor padrao inicial) - 0: nao 1:sim
    var dhserver_ctrl_obrigatorio = "0"; // indica se o ctrl deve ser pressionado com a selecao (valor padrao inicial) - 0: nao 1:sim
    var dhserver_pos_inicial = "ne"; // indica posicao inicial da caixa de buscas na tela (valor padrao inicial) - se, sw, nw, ne
    var dhserver_funcoes_html = "1"; // indica se o retorno html e apenas visual ou se as palavras sao clicaveis (valor padrao inicial) - 1: clicavel 2: nao clicavel
    var dhserver_mostrar = "1"; // indica se janela de busca deve ser mostrada ao carregar a biblioteca - 1:sim 2:nao
    // variaveis adicionais (cuidado: alteracoes podem causar serios problemas)
    var dhserver_origin = location.origin; // origem do website atual
    var dhserver_protocol = location.protocol; // protocolo do website atual
    var dhserver_endereco_auth = dhserver_protocol + "//" + dhserver_endereco + "/h_auth.php"; // endereco local e nome do arquivo h_auth.php (ex. 'http://meudominio.com/hserver/h_auth.php')
    var dhserver_endereco_busca = dhserver_protocol + "//" + dhserver_endereco + "/h_busca.htm"; // endereco local e nome do arquivo h_busca.htm (ex. 'http://meudominio.com/hserver/h_busca.htm')
    var dhserver_endereco_busca_min = dhserver_protocol + "//" + dhserver_endereco + "/h_busca_min.htm"; // endereco local e nome do arquivo h_busca_min.htm (ex. 'http://meudominio.com/hserver/h_busca_min.htm')
    var conteudo_height_max = 400; // altura maxima do conteudo do verbete
    var iframe_width = 350; // largura do iframe
    var dhserver_serial; // serial desta instalacao
    var dhserver_estado = "min"; // estado da iframe - min:minimizado max:maximizado
    var dhserver_forma_retorno = "html2"; // forma de entrega da informacao pelo servidor
    var obj_pos_selection = {};
    var dhserver_busca_anterior = "";
    var dhserver_mc_mousebutton;
    var dhserver_mc_mouseover;
    var dhserver_alt_pressionado = 0;
    var dhserver_ctrl_pressionado = 0;
    var dhserver_timer_h_selecao = null;
    // variaveis auxiliares
    var ajax;
    var timer_busca = null;
    var timer_minshow = null;
    // obtem as coordenadas do select
    var f_dhserver_coordenadas_select = function(obj_selecao) {
        // se ha selecao e rangecount
        if (obj_selecao && obj_selecao.rangeCount > 0) {
            // tenta estabelecer o objeto que contem os limites da selecao
            if (obj_selecao.getRangeAt(0).getBoundingClientRect()) {
                obj_pos_selection = obj_selecao.getRangeAt(0).getBoundingClientRect();
            }
        }
    }

    // coloca um conteudo dentro da iframe
    publico.f_dhserver_carregar = function(tipo) {
        // carregar o campo maximizado
        if (tipo == "max") {
            // apaga o agendamento de busca
            clearInterval(timer_minshow);
            timer_minshow = null;
            //
            document.getElementById("elm_dhserver_conteudo").style.position = "fixed";
            document.getElementById("elm_dhserver_conteudo").style.maxWidth = iframe_width + "px";
            document.getElementById("elm_dhserver_conteudo").style.minWidth = iframe_width + "px";
            document.getElementById("elm_dhserver_conteudo").style.height = "70px";
            document.getElementById("elm_dhserver_conteudo").style.padding = "0px";
            document.getElementById("elm_dhserver_conteudo").style.borderWidth = "0px";
            document.getElementById("elm_dhserver_conteudo").style.backgroundColor = "#ffffff";
            document.getElementById("elm_dhserver_conteudo").style.boxShadow = "0px 0px 15px 0px rgba(0,0,0,0.7)";
            // insere conteudo html (se usar .src cria history enter)
            //document.getElementById("elm_dhserver_conteudo").location.replace(dhserver_endereco_busca);
            document.getElementById("elm_dhserver_conteudo").contentWindow.location.replace(dhserver_endereco_busca);
        }
        // carregar o campo minimizado
        else if (tipo == "min") {
            document.getElementById("elm_dhserver_conteudo").style.position = "fixed";
            document.getElementById("elm_dhserver_conteudo").style.maxWidth = "30px";
            document.getElementById("elm_dhserver_conteudo").style.minWidth = "30px";
            document.getElementById("elm_dhserver_conteudo").style.height = "30px";
            document.getElementById("elm_dhserver_conteudo").style.padding = "0px";
            document.getElementById("elm_dhserver_conteudo").style.borderWidth = "0px";
            document.getElementById("elm_dhserver_conteudo").style.backgroundColor = "#ffffff";
            document.getElementById("elm_dhserver_conteudo").style.boxShadow = "0px 0px 10px 0px rgba(0,0,0,0.7)";
            document.getElementById("elm_dhserver_conteudo").style.display = "none";
            // insere conteudo html (se usar .src cria history enter)
            //document.getElementById("elm_dhserver_conteudo").src = dhserver_endereco_busca_min;
            document.getElementById("elm_dhserver_conteudo").contentWindow.location.replace(dhserver_endereco_busca_min);
            // mostra-a em um instante
            timer_minshow = setTimeout(function() {
                document.getElementById("elm_dhserver_conteudo").style.display = "inline";
            }, 500);
        }
    }

    // altera o valor de uma variavel
    publico.f_dhserver_alterar = function(variavel, valor) {
        var retorno;
        if (variavel == "dhserver_dicionario") { dhserver_dicionario = valor; }
        else if (variavel == "dhserver_duplo_clique") { dhserver_duplo_clique = valor; }
        else if (variavel == "dhserver_alt_obrigatorio") { dhserver_alt_obrigatorio = valor; }
        else if (variavel == "dhserver_ctrl_obrigatorio") { dhserver_ctrl_obrigatorio = valor; }
        else if (variavel == "dhserver_pos_inicial") { dhserver_pos_inicial = valor; }
        else if (variavel == "dhserver_funcoes_html") { dhserver_funcoes_html = valor; }
        else if (variavel == "dhserver_mostrar") { dhserver_mostrar = valor; }
    };

    // faz a busca de um verbete digitado
    publico.f_dhserver_buscar2 = function(texto) {
    	// se algum texto esta definido executa o if
    	if (texto != "") {
            // se o texto e diferente da ultima pesquisa por digitacao executa o if
            if (texto != dhserver_busca_anterior) {
                // define o texto a ser enviado ao servidor
                dhserver_busca_anterior = texto;
                // se uma busca esta agendada executa o if
                if (typeof timer_busca == "undefined") { timer_busca = null; }
                if (timer_busca != null) {
                    // apaga o agendamento de busca
                    clearInterval(timer_busca);
                    timer_busca = null;
                    // se uma atividade ajax esta em andamento aborta-a
                    if ((typeof ajax != "undefined")&&(ajax.readyState >= 0)) {
                        ajax.abort();
                        // apaga o sinal de busca
                        f_dhserver_post_message("f_apagar_sinal_busca", "", "");
                        //document.getElementById("elm_dhserver_conteudo").contentWindow.f_apagar_sinal_busca();
                    }
                }
                // roda o ajax
                f_dhserver_post_message("f_mostrar_sinal_busca", "", "");
                //document.getElementById("elm_dhserver_conteudo").contentWindow.f_mostrar_sinal_busca();
                // faz um novo agendamento de busca
                timer_busca = setTimeout(function() {
                    // busca a palavra em fracao de segundo
                    f_dhserver_buscar(texto, 0);
                }, 700);
            }
            // se o texto e igual
            else {
                // nao faz nada
            }
        }
        // se nenhum texto esta definido
    	else {
            // se uma busca esta agendada executa o if
            if (typeof timer_busca == "undefined") { timer_busca = null; }
            if (timer_busca != null) {
                // apaga o agendamento de busca
                clearInterval(timer_busca);
                timer_busca = null;
                // se uma atividade ajax esta em andamento aborta-a
                if ((typeof ajax != "undefined")&&(ajax.readyState >= 0)) {
                    ajax.abort();
                    // apaga o sinal de busca
                    f_dhserver_post_message("f_apagar_sinal_busca", "", "");
                    //document.getElementById("elm_dhserver_conteudo").contentWindow.f_apagar_sinal_busca();
                }
            }
            // apaga a div conteudo
            f_dhserver_apagar_conteudo();
        }
    };

    // executa uma busca por verbete clicado
    publico.f_dhserver_buscar3 = function(texto) {
        f_dhserver_buscar(texto, 0);
    };

    // funcao que obtem e guarda as dimensoes da janela
    var f_dhserver_dados_tela = function(info) {
        var retorno;
        // resolucao x
        if (info == "resx") {
            retorno = window.innerWidth || window.innerWidth;
        }
        // resolucao y
        else if (info == "resy") {
            retorno = window.innerHeight || window.innerHeight;
        }
        // resolucao x (desconta scrollbar se houver)
        if (info == "resx-scroll") {
            retorno = document.documentElement.clientWidth || document.body.clientWidth;
        }
        // resolucao y (desconta scrollbar se houver)
        else if (info == "resy-scroll") {
            retorno = document.documentElement.clientHeight || document.body.clientHeight;
        }
        // resolucao x total (quando maximizada)
        if (info == "resxtot") {
            retorno = screen.availWidth;
        }
        // resolucao y total (quando maximizada)
        else if (info == "resytot") {
            retorno = screen.availHeight;
        }
        return retorno;
    }

    // desliga a busca
    publico.f_dhserver_desligar_busca = function() {
        // ajusta variaveis
        localStorage.setItem("dhserver_mostrar", "2");
        dhserver_mostrar = localStorage.getItem("dhserver_mostrar");
        // ajusta a tela
        document.getElementById("elm_dhserver_conteudo").style.visibility = "hidden";
        dhserver_estado = "min";
    };

    // configuracao altera dados
    publico.f_dhserver_executar = function(nome, valor) {
        // duplo clique
        if (nome == "duplo_clique") {
            if (valor == "0") { dhserver_duplo_clique = "0"; dhserver_alt_obrigatorio = "0"; dhserver_ctrl_obrigatorio = "0"; }
            else if (valor == "1") { dhserver_duplo_clique = "1"; dhserver_alt_obrigatorio = "0"; dhserver_ctrl_obrigatorio = "0"; }
            else if (valor == "2") { dhserver_duplo_clique = "1"; dhserver_alt_obrigatorio = "1"; dhserver_ctrl_obrigatorio = "0"; }
            else if (valor == "3") { dhserver_duplo_clique = "1"; dhserver_alt_obrigatorio = "0"; dhserver_ctrl_obrigatorio = "1"; }
            else if (valor == "4") { dhserver_duplo_clique = "1"; dhserver_alt_obrigatorio = "0"; dhserver_ctrl_obrigatorio = "0"; }
        }
        // posicionamento
        if (nome == "pos_inicial") {
            if (valor == "se") {
                document.getElementById("elm_dhserver_conteudo").style.top = "";
                document.getElementById("elm_dhserver_conteudo").style.left = "";
                document.getElementById("elm_dhserver_conteudo").style.right = "10px";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "10px";
            }
            else if (valor == "sw") {
                document.getElementById("elm_dhserver_conteudo").style.top = "";
                document.getElementById("elm_dhserver_conteudo").style.left = "10px";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "10px";
                document.getElementById("elm_dhserver_conteudo").style.right = "";
            }
            else if (valor == "nw") {
                document.getElementById("elm_dhserver_conteudo").style.top = "10px";
                document.getElementById("elm_dhserver_conteudo").style.left = "10px";
                document.getElementById("elm_dhserver_conteudo").style.right = "";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "";
            }
            else if (valor == "ne") {
                document.getElementById("elm_dhserver_conteudo").style.top = "10px";
                document.getElementById("elm_dhserver_conteudo").style.left = "";
                document.getElementById("elm_dhserver_conteudo").style.right = "10px";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "";
            }
        }
    };

    // informa o valor de uma variavel
    publico.f_dhserver_informar = function(variavel) {
        if (variavel == "dhserver_dicionario") { return dhserver_dicionario; }
        else if (variavel == "dhserver_duplo_clique") { return dhserver_duplo_clique; }
        else if (variavel == "dhserver_alt_obrigatorio") { return dhserver_alt_obrigatorio; }
        else if (variavel == "dhserver_ctrl_obrigatorio") { return dhserver_ctrl_obrigatorio; }
        else if (variavel == "dhserver_pos_inicial") { return dhserver_pos_inicial; }
        else if (variavel == "dhserver_funcoes_html") { return dhserver_funcoes_html; }
        else if (variavel == "dhserver_mostrar") { return dhserver_mostrar; }
    };

    // inicia o complemento
    publico.f_dhserver_iniciar = function() {
        // aguarda um instante
        setTimeout(function() {
            // le as configuracoes
            f_dhserver_ler_configuracao();
            // cria a iframe de conteudo
            f_dhserver_criar_conteudo();
        }, 500);
    };

    // liga a busca
    publico.f_dhserver_ligar_busca = function() {
        // ajusta variaveis
        localStorage.setItem("dhserver_mostrar", "1");
        dhserver_mostrar = localStorage.getItem("dhserver_mostrar");
        // ajusta a tela
        document.getElementById("elm_dhserver_conteudo").style.visibility = "visible";
        dhserver_estado = "max";
        dhserver.f_dhserver_carregar(dhserver_estado);
    };

    // salva dados no storage
    publico.f_dhserver_salvar_configuracao = function(tipo, valor) {
        localStorage.setItem(tipo, valor);
    };

    // cria ajax
    var f_dhserver_ajax = function() {
        if (window.XMLHttpRequest) { // Mozilla, Safari, ...
            ajax = new XMLHttpRequest();
        } else if (window.ActiveXObject) { // IE 8 and older
            ajax = new ActiveXObject("Microsoft.XMLHTTP");
        }
    };

    // apaga conteudo da iframe
    var f_dhserver_apagar_conteudo = function() {
        // se a div de busca esta ativa executa o if
        if (document.getElementById("elm_dhserver_conteudo")) {
            // apaga os conteudos
            f_dhserver_post_message("f_apagar_conteudo", "", "");
            //document.getElementById("elm_dhserver_conteudo").contentWindow.f_apagar_conteudo();
            // ajusta tamanho
            document.getElementById("elm_dhserver_conteudo").style.height = "70px";
        }
    };

    // apaga selecao
    var f_dhserver_apagar_select = function() {
        if (window.getSelection) {
            if (window.getSelection().empty) {  // Chrome
                window.getSelection().empty();
            }
            else if (window.getSelection().removeAllRanges) {  // Firefox
                window.getSelection().removeAllRanges();
            }
        }
        else if (document.selection) {  // IE
            if (window.getSelection().empty) {
                window.getSelection().empty();
            }
        }
    };

    // faz a busca de um verbete clicado
    var f_dhserver_buscar = function(texto, realocar) {
    	var page_encoding = "", zindex_max;
        var distup, distdown, poscentro, posleft, posright, maxheight_calc, minheight_calc;
        var pos_x, pos_y;
    	// se algum texto esta definido executa o if
    	if (texto != "") {
            // iframe deve ser mostrada
            localStorage.setItem("dhserver_mostrar", "1");
            dhserver_mostrar = localStorage.getItem("dhserver_mostrar");
            // se esta minimizado
            if (dhserver_estado == "min") {
                // maximiza a iframe
                dhserver_estado = "max";
                dhserver.f_dhserver_carregar(dhserver_estado);
            }
            // se as coordenadas do select estao definidas (nunca estao no load) e e para realocar o iframe
            if ((typeof obj_pos_selection != "undefined")&&(realocar == 1)) {
                // se as coordenadas estao definidas
                if ((obj_pos_selection.left)&&(obj_pos_selection.top)&&(obj_pos_selection.right)&&(obj_pos_selection.bottom)) {
                    //console.log(obj_pos_selection.left+"|"+obj_pos_selection.top+"|"+obj_pos_selection.right+"|"+obj_pos_selection.bottom);
                    // trata da posicao y
                    distup = Math.round(obj_pos_selection.top);
                    distdown = Math.round(f_dhserver_dados_tela("resy-scroll") - Number(obj_pos_selection.bottom));
                    // // se a distancia abaixo e maior ou igual ou se a distancia superior e muito pequena
                    if ((distdown >= distup)||(distup < 150)) {
                        pos_y = Number(obj_pos_selection.bottom) + 10;
                        document.getElementById("elm_dhserver_conteudo").style.top = pos_y + "px";
                        document.getElementById("elm_dhserver_conteudo").style.bottom = "";
                    }
                    // // se a distancia abaixo e menor coloca acima
                    else {
                        pos_y = Number(obj_pos_selection.top) - 10;
                        document.getElementById("elm_dhserver_conteudo").style.bottom = (f_dhserver_dados_tela("resy-scroll") - pos_y) + "px";
                        document.getElementById("elm_dhserver_conteudo").style.top = "";
                    }
                    // trata da posicao x
                    poscentro = (Number(obj_pos_selection.left) + Number(obj_pos_selection.right)) / 2;
                    posleft = Math.round(poscentro - (iframe_width / 2));
                    posright = Math.round(poscentro + (iframe_width / 2));
                    // // nao permite passar dos limites direito ou esquerdo
                    if (posleft < 10) {
                        document.getElementById("elm_dhserver_conteudo").style.left = "10px";
                        document.getElementById("elm_dhserver_conteudo").style.right = "";
                    }
                    else if (posright > f_dhserver_dados_tela("resx-scroll") - 10) {
                        document.getElementById("elm_dhserver_conteudo").style.right = "10px";
                        document.getElementById("elm_dhserver_conteudo").style.left = "";
                    }
                    else {
                        document.getElementById("elm_dhserver_conteudo").style.left = posleft + "px";
                        document.getElementById("elm_dhserver_conteudo").style.right = "";
                    }
                }
            }
            // define o ajax
            f_dhserver_ajax();
            // roda a imagem
            f_dhserver_post_message("f_mostrar_sinal_busca", "", "");
            //document.getElementById("elm_dhserver_conteudo").contentWindow.f_mostrar_sinal_busca();
    	    // define funcao de processamento no retorno
    	    ajax.onreadystatechange = f_dhserver_processar_busca;
            // envia a solicitacao ajax
    	    ajax.open("GET", dhserver_endereco_auth + "?dicionario=" + escape(dhserver_dicionario)
             + "&palavra=" + escape(texto) + "&srl=" + escape(dhserver_serial) + "&formato=" + dhserver_forma_retorno, true);
            ajax.send();
            // apaga a selecao
            f_dhserver_apagar_select();
        }
    };

    // cria iframe conteudo
    var f_dhserver_criar_conteudo = function() {
    	var iframe;
    	// se a iframe nao esta definida executa o if
        if (!(document.getElementById("elm_dhserver_conteudo"))) {
            // cria a iframe
        	iframe = document.createElement("iframe");
        	iframe.id = "elm_dhserver_conteudo";
            document.body.appendChild(iframe);
            // mostra conteudo
            //console.log("dhserver_mostrar:"+dhserver_mostrar);
            if (dhserver_mostrar == "1") { document.getElementById("elm_dhserver_conteudo").style.visibility = "visible"; }
            else if (dhserver_mostrar == "2") { document.getElementById("elm_dhserver_conteudo").style.visibility = "hidden"; }
            dhserver.f_dhserver_carregar("min");
            // executa procedimentos iniciais
            dhserver.f_dhserver_executar("pos_inicial", dhserver_pos_inicial);
        	// variaveis para conteudo
            dhserver_mc_mousebutton = false;
            dhserver_mc_mouseover = false;
        	// fica de olho no botao do mouse
            window.onmousedown = function(evt) { f_dhserver_mousebutton_down(evt); };
            window.onmouseup = function(evt) { f_dhserver_mousebutton_up(evt); };
            // fica de olho na posicao do mouse
            document.getElementById("elm_dhserver_conteudo").onmouseover = function(evt) { f_dhserver_mouse_over(); };
            document.getElementById("elm_dhserver_conteudo").onmouseout = function(evt) { f_dhserver_mouse_out(); };
            // fica de olho no select
            dhserver_timer_h_selecao = setInterval(f_dhserver_relogio_corporativo, 300);
        }
    };

    // le dados do storage
    var f_dhserver_ler_configuracao = function() {
        // dicionario
        if (!f_dhserver_localstorage("dhserver_dicionario")) {
            localStorage.setItem("dhserver_dicionario", dhserver_dicionario);
        }
        else {
            dhserver_dicionario = localStorage.getItem("dhserver_dicionario");
        }
        // duplo clique
        if (!f_dhserver_localstorage("dhserver_duplo_clique")) {
            localStorage.setItem("dhserver_duplo_clique", dhserver_duplo_clique);
        }
        else {
            dhserver_duplo_clique = localStorage.getItem("dhserver_duplo_clique");
        }
        // alt pressionado
        if (!f_dhserver_localstorage("dhserver_alt_obrigatorio")) {
            localStorage.setItem("dhserver_alt_obrigatorio", "1");
        }
        else {
            dhserver_alt_obrigatorio = localStorage.getItem("dhserver_alt_obrigatorio");
        }
        // ctrl pressionado
        if (!f_dhserver_localstorage("dhserver_ctrl_obrigatorio")) {
            localStorage.setItem("dhserver_ctrl_obrigatorio", dhserver_ctrl_obrigatorio);
        }
        else {
            dhserver_ctrl_obrigatorio = localStorage.getItem("dhserver_ctrl_obrigatorio");
        }
        // posicao inicial
        if (!f_dhserver_localstorage("dhserver_pos_inicial")) {
            localStorage.setItem("dhserver_pos_inicial", dhserver_pos_inicial);
        }
        else {
            dhserver_pos_inicial = localStorage.getItem("dhserver_pos_inicial");
        }
        // funcoes html
        if (!f_dhserver_localstorage("dhserver_funcoes_html")) {
            localStorage.setItem("dhserver_funcoes_html", dhserver_funcoes_html);
        }
        else {
            dhserver_funcoes_html = localStorage.getItem("dhserver_funcoes_html");
        }
        // formato
        if (!f_dhserver_localstorage("dhserver_mostrar")) {
            localStorage.setItem("dhserver_mostrar", dhserver_mostrar);
        }
        else {
            dhserver_mostrar = localStorage.getItem("dhserver_mostrar");
        }
        // serial
        if (!f_dhserver_localstorage("dhserver_serial")) {
            localStorage.setItem("dhserver_serial", f_dhserver_serial(10));
            dhserver_serial = f_dhserver_serial(10);
        }
        else {
            dhserver_serial = localStorage.getItem("dhserver_serial");
        }
    };

    // garante uma variavel localstorage
    function f_dhserver_localstorage(variavel) {
        if (localStorage.getItem(variavel) == null) {
            return false;
        }
        if (typeof localStorage.getItem(variavel) == "undefined") {
            return false;
        }
        if (localStorage.getItem(variavel) == "undefined") {
            return false;
        }
        else return true;
    };

    // determina estado do botao do mouse
    var f_dhserver_mousebutton_down = function(evt) {
    	dhserver_mc_mousebutton = true;
        // se o mouse nao esta sobre o iframe e ela esta visivel
    	if ((dhserver_mc_mouseover == false)&&(dhserver_mostrar == "1")&&(dhserver_estado == "max")) {
    		// minimiza a iframe
            dhserver_estado = "min";
            dhserver.f_dhserver_carregar(dhserver_estado);
            // coloca a iframe no lugar correto
            if (dhserver_pos_inicial == "se") {
                document.getElementById("elm_dhserver_conteudo").style.top = "";
                document.getElementById("elm_dhserver_conteudo").style.left = "";
                document.getElementById("elm_dhserver_conteudo").style.right = "10px";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "10px";
            }
            else if (dhserver_pos_inicial == "sw") {
                document.getElementById("elm_dhserver_conteudo").style.top = "";
                document.getElementById("elm_dhserver_conteudo").style.left = "10px";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "10px";
                document.getElementById("elm_dhserver_conteudo").style.right = "";
            }
            else if (dhserver_pos_inicial == "nw") {
                document.getElementById("elm_dhserver_conteudo").style.top = "10px";
                document.getElementById("elm_dhserver_conteudo").style.left = "10px";
                document.getElementById("elm_dhserver_conteudo").style.right = "";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "";
            }
            else if (dhserver_pos_inicial == "ne") {
                document.getElementById("elm_dhserver_conteudo").style.top = "10px";
                document.getElementById("elm_dhserver_conteudo").style.left = "";
                document.getElementById("elm_dhserver_conteudo").style.right = "10px";
                document.getElementById("elm_dhserver_conteudo").style.bottom = "";
            }
    	}
    };

    // estica iframe e calcula novas coordenadas
    publico.f_dhserver_ajustar_altura = function() {
        var top_y, bottom_y, distdown, distup, conteudo_height;
        // ajusta altura
        top_y = document.getElementById("elm_dhserver_conteudo").style.top;
        bottom_y = document.getElementById("elm_dhserver_conteudo").style.bottom;
        // // se o top esta definido
        if (top_y != "") {
            // calcula a distancia disponivel para baixo
            top_y = Number(top_y.replace("px", ""));
            distdown = Math.round(f_dhserver_dados_tela("resy-scroll") - top_y - 70 - 10);
            // determina o tamanho a disponibilizar
            if (distdown >= 50) {
                if (distdown > conteudo_height_max) { conteudo_height = conteudo_height_max; }
                else { conteudo_height = distdown; }
            }
            else { conteudo_height = 50; }
        }
        // // se o bottom esta definido
        else if (bottom_y != "") {
            // calcula a distancia disponivel para baixo
            bottom_y = Number(bottom_y.replace("px", ""));
            distup = Math.round(f_dhserver_dados_tela("resy-scroll") - bottom_y - 70 - 10);
            // determina o tamanho a disponibilizar
            if (distup >= 50) {
                if (distup > conteudo_height_max) { conteudo_height = conteudo_height_max; }
                else { conteudo_height = distup; }
            }
            else { conteudo_height = 50; }
        }
        else {
            conteudo_height = conteudo_height_max;
        }
        // ajusta o tamanho do iframe
        document.getElementById("elm_dhserver_conteudo").style.height = 70 + conteudo_height + "px";
        // retorna o tamanho da div conteudo disponivel
        return conteudo_height;
    };

    // determina estado do botao do mouse
    var f_dhserver_mousebutton_up = function(evt) {
    	// verifica se alt esta pressinado neste momento
    	if (evt.altKey) { dhserver_alt_pressionado = "1"; }
    	else { dhserver_alt_pressionado = "0"; }
    	// verifica se ctrl esta pressinado neste momento
    	if (evt.ctrlKey) { dhserver_ctrl_pressionado = "1"; }
    	else { dhserver_ctrl_pressionado = "0"; }
    	//
    	dhserver_mc_mousebutton = false;
    };

    // determina mouse sobre a div
    var f_dhserver_mouse_over = function() {
    	dhserver_mc_mouseover = true;
        //console.log("dentro");
    };

    // determina mouse fora da div
    var f_dhserver_mouse_out = function() {
    	dhserver_mc_mouseover = false;
        //console.log("fora");
    };

    // obtem o encoding da pagina atual
    var f_dhserver_page_encoding = function() {
    	var page_encoding = "";
    	if (document.inputEncoding) { page_encoding = document.inputEncoding; }
    	return page_encoding;
    };

    // funcao que obtem e guarda as dimensoes da janela
    var f_dhserver_post_message = function(tipo, texto1, texto2) {
        //console.log("envio mensagem p iframe:"+"dhserver<1>"+tipo + "<1>" + texto1 + "<1>" + texto2);
        document.getElementById("elm_dhserver_conteudo").contentWindow.postMessage("dhserver<1>" + tipo + "<1>" + texto1 + "<1>" + texto2, "*");
    }

    // mostra o resultado da busca
    var f_dhserver_processar_busca = function() {
        var resposta_html, altura_divconteudo;
        if (ajax.readyState == 4) {
            var obj = document.getElementById("elm_dhserver_conteudo");
            // inclui verbetes clicaveis ou nao
            if (dhserver_funcoes_html == "1") { resposta_html = f_dhserver_verbetes_clicaveis(ajax.responseText); }
            else { resposta_html = ajax.responseText; }
            // ajusta iframe
            altura_divconteudo = dhserver.f_dhserver_ajustar_altura();
            // mostra o conteudo em um instante
            setTimeout(function() {
                f_dhserver_post_message("f_mostrar_conteudo", resposta_html, altura_divconteudo);
                // coloca um zindex apropriado
                zindex_max = f_dhserver_zmax("div");
                if (Number(zindex_max) < 1000) { zindex_max = 1001; }
                else { zindex_max = Number(zindex_max) + 1; }
                obj.style.zIndex = zindex_max;
                // mostra a div de conteudo
                obj.style.display = "block";
                // se a div de busca esta ativa executa o if
                if (document.getElementById("elm_dhserver_conteudo")) {
                    // apaga o sinal de busca
                    f_dhserver_post_message("f_apagar_sinal_busca", "", "");
                    //document.getElementById("elm_dhserver_conteudo").contentWindow.f_apagar_sinal_busca();
                }
            }, 300);
        }
    };

    // recebe mensagens da iframe
    publico.f_dhserver_receive_message = function(event) {
        var ary_partes, mensagem, altura_divconteudo;
        console.log("recebi mensagem de iframe:"+event.data+" origem:"+event.origin+" eu:"+dhserver_origin);
        // define a mensagem
        mensagem = event.data;
        ary_partes = mensagem.split("<1>");
        // se a mensagem esta corretamente formatada
        if ((ary_partes.length == 4)&&(ary_partes[0] == "dhserver")) {
            // se e para ajustar altura da iframe e mostrar configuracao
            if (ary_partes[1] == 1) {
                // ajusta iframe
                altura_divconteudo = dhserver.f_dhserver_ajustar_altura();
                // mostra o conteudo da configuracao em um instante
                setTimeout(function() {
                    f_dhserver_post_message("f_mostrar_conteudo", ary_partes[2], altura_divconteudo);
                    // atualiza com as configuracoes atuais em um instante
                    setTimeout(function() {
                        dhserver.f_dhserver_telaconfig()
                    }, 50);
                }, 300);
            }
            // se e para ligar a busca
            else if (ary_partes[1] == 2) {
                dhserver.f_dhserver_ligar_busca();
            }
            // se e para desligar a busca
            else if (ary_partes[1] == 3) {
                dhserver.f_dhserver_desligar_busca();
            }
            // se e para desligar a busca
            else if (ary_partes[1] == 3) {
                dhserver.f_dhserver_desligar_busca();
            }
            // se e para alterar info de configuracao
            else if (ary_partes[1] == 4) {
                dhserver.f_dhserver_alterar(ary_partes[2], ary_partes[3]);
            }
            // salva variavel em localstorage
            else if (ary_partes[1] == 5) {
                dhserver.f_dhserver_salvar_configuracao(ary_partes[2], ary_partes[3]);
            }
            // altera dados em funcao de nova configuracao
            else if (ary_partes[1] == 6) {
                dhserver.f_dhserver_executar(ary_partes[2], ary_partes[3]);
            }
            // atualizar stylesheet
            else if (ary_partes[1] == 7) {
                dhserver.f_dhserver_stylesheet();
            }
            // atualizar tela com configuracao atual
            else if (ary_partes[1] == 8) {
                dhserver.f_dhserver_telaconfig();
            }
            // busca por palavra digitada
            else if (ary_partes[1] == 9) {
                dhserver.f_dhserver_buscar2(ary_partes[2]);
            }
            // busca por palavra clicada
            else if (ary_partes[1] == 10) {
                dhserver.f_dhserver_buscar3(ary_partes[2]);
            }
        }
    }

    // verifica de tempos em tempos se algo foi selecionado
    var f_dhserver_relogio_corporativo = function() {
        var texto;
        var coordenadas1;
        var coordenadas2;
        // se o duplo clique esta ativo executa o if
        if (dhserver_duplo_clique == "1") {
            // obtem o texto selecionado. o metodo depende do navegador
            if (window.getSelection) { texto = window.getSelection(); }
            else if (document.getSelection) { texto = document.getSelection(); }
            else if (document.selection) { texto = document.selection.createRange().text; }
            else { texto = ""; }
            // determina as coordenadas da selecao
            f_dhserver_coordenadas_select(texto);
            // converte pata string
            texto = texto.toString();
            // remove tags
            var pattern = /<(.|\n)*?>/;
            texto = texto.replace(/<(.|\n)*?>/g, "a");
            // limita a 30 caracteres
            texto = texto.trim();
            texto = texto.substr(0, 30);
            // se o texto esta definido e o botao esta solto executa o if
            if ((texto != "")&&(dhserver_mc_mousebutton == false)) {
                // verifica a obrigatoriedade do ctrl e alt
                if (((dhserver_alt_obrigatorio == "0")&&(dhserver_ctrl_obrigatorio == "0"))||
                ((dhserver_alt_obrigatorio == "1")&&(dhserver_ctrl_obrigatorio == "0")&&(dhserver_alt_pressionado == "1"))||
                ((dhserver_alt_obrigatorio == "0")&&(dhserver_ctrl_obrigatorio == "1")&&(dhserver_ctrl_pressionado == "1"))||
                ((dhserver_alt_obrigatorio == "1")&&(dhserver_alt_pressionado == "1")&&(dhserver_ctrl_obrigatorio == "1")&&(dhserver_ctrl_pressionado == "1"))) {
            	    document.getElementById("elm_dhserver_conteudo").style.visibility = "visible";
                    f_dhserver_post_message("f_mostrar_sinal_busca", "", "");
                    //document.getElementById("elm_dhserver_conteudo").contentWindow.f_mostrar_sinal_busca();
                    f_dhserver_buscar(texto, 1);
                }
            }
        }
    };

    // gera um serial aleatorio com N caracteres
    var f_dhserver_serial = function(tamanho) {
        var i;
        var text = "";
        var possible = "abcdefghijklmnopqrstuvwxyz0123456789";
        // gera o serial
        for (i = 0; i < tamanho; i++) {
            text += possible.charAt(Math.floor(Math.random() * possible.length));
        }
        return text;
    };

    // troca a stylesheet (desligado. O stylesheet permanece)
    publico.f_dhserver_stylesheet = function() {
        /*
        // se o dicionario atual e sinonimos e antonimos
    	if (dhserver.f_dhserver_informar("dhserver_dicionario") == "sinant") {
            // troca para a stylesheet necessaria
            f_dhserver_post_message("stylesheet", "sinant", "");
    	}
    	else if (dhserver.f_dhserver_informar("dhserver_dicionario") == "grande") {
            // troca para a stylesheet necessaria
            f_dhserver_post_message("stylesheet", "grande", "");
    	}
        */    
    }

    // atualiza a tela com as configuracoes atuais
    publico.f_dhserver_telaconfig = function() {
        console.log("atualizo tela config");
        // dicionario
        if (dhserver.f_dhserver_informar("dhserver_dicionario") == "grande") { f_dhserver_post_message("checked", "elm_dic_grande", 1); }
        else if (dhserver.f_dhserver_informar("dhserver_dicionario") == "sinant") { f_dhserver_post_message("checked", "elm_dic_sinant", 1); }
        // duplo clique
        if (dhserver.f_dhserver_informar("dhserver_duplo_clique") == "1") {
            //document.getElementById("elm_duplo_clique").checked = true;
            f_dhserver_post_message("checked", "elm_duplo_clique", 1);
            //document.getElementById("elm_alt_obrigatorio").disabled = false;
            f_dhserver_post_message("disabled", "elm_alt_obrigatorio", 0);
            //document.getElementById("elm_ctrl_obrigatorio").disabled = false;
            f_dhserver_post_message("disabled", "elm_ctrl_obrigatorio", 0);
        }
        else if (dhserver.f_dhserver_informar("dhserver_duplo_clique") == "0") {
            //document.getElementById("elm_duplo_clique").checked = false;
            f_dhserver_post_message("checked", "elm_duplo_clique", 0);
            //document.getElementById("elm_alt_obrigatorio").disabled = true;
            f_dhserver_post_message("disabled", "elm_alt_obrigatorio", 1);
            //document.getElementById("elm_ctrl_obrigatorio").disabled = true;
            f_dhserver_post_message("disabled", "elm_ctrl_obrigatorio", 1);
        }
        // alt pressionado
        if (dhserver.f_dhserver_informar("dhserver_alt_obrigatorio") == "1") {
            //document.getElementById("elm_alt_obrigatorio").checked = true;
            f_dhserver_post_message("checked", "elm_alt_obrigatorio", 1);
        }
        else if (dhserver.f_dhserver_informar("dhserver_alt_obrigatorio") == "0") {
            //document.getElementById("elm_alt_obrigatorio").checked = false;
            f_dhserver_post_message("checked", "elm_alt_obrigatorio", 0);
        }
        // ctrl pressionado
        if (dhserver.f_dhserver_informar("dhserver_ctrl_obrigatorio") == "1") {
            //document.getElementById("elm_ctrl_obrigatorio").checked = true;
            f_dhserver_post_message("checked", "elm_ctrl_obrigatorio", 1);
        }
        else if (dhserver.f_dhserver_informar("dhserver_ctrl_obrigatorio") == "0") {
            //document.getElementById("elm_ctrl_obrigatorio").checked = false;
            f_dhserver_post_message("checked", "elm_ctrl_obrigatorio", 0);
        }
        // posicao inicial
        if (dhserver.f_dhserver_informar("dhserver_pos_inicial") == "se") { f_dhserver_post_message("checked", "elm_pos_se", 1); }
        else if (dhserver.f_dhserver_informar("dhserver_pos_inicial") == "sw") { f_dhserver_post_message("checked", "elm_pos_sw", 1); }
        else if (dhserver.f_dhserver_informar("dhserver_pos_inicial") == "nw") { f_dhserver_post_message("checked", "elm_pos_nw", 1); }
        else if (dhserver.f_dhserver_informar("dhserver_pos_inicial") == "ne") { f_dhserver_post_message("checked", "elm_pos_ne", 1); }
        // verbetes clicaveis
        if (dhserver.f_dhserver_informar("dhserver_funcoes_html") == "1") { f_dhserver_post_message("checked", "elm_verbetes_clicaveis", 1); }
        else if (dhserver.f_dhserver_informar("dhserver_funcoes_html") == "2") { f_dhserver_post_message("checked", "elm_verbetes_clicaveis", 0); }
    };

    // torna as palavras do verbete clicaveis
    var f_dhserver_verbetes_clicaveis = function(conteudo) {
    	var partes, i, posfim, palavra_busca, palavra_mostrar, parte_alterada, novo_conteudo = "";
    	partes = conteudo.split("<r>");
    	// percorre as tags
    	for (var i in partes) {
    		// procura o final da tag atual
    		posfim = partes[i].indexOf("</r>");
    		// se o fim existe
    		if (posfim != -1) {
    			// define a palavra de busca
    			palavra_busca = partes[i].substr(0, posfim);
    			palavra_busca = palavra_busca.toLowerCase();
    			if (palavra_busca.substr(-3) == "-se") { palavra_busca = palavra_busca.substr(0, palavra_busca.length - 3); }
    			// define a palavra a mostrar
    			palavra_mostrar = partes[i].substr(0, posfim);
    			// define a nova parte atual
    			parte_alterada = "<span id=\"elm_clic"+i+"\" class=\"vc\" onclick=\"f_buscar('"+palavra_busca+"#e',"+i+")\">"+palavra_mostrar+"</span>"+partes[i].substr(posfim + 4);
    		}
    		else {
    			// a parte atual nao muda
    			parte_alterada = partes[i];
    		}
    		// acumula a parte atual no retorno
    		novo_conteudo += parte_alterada;
    	}
    	return novo_conteudo;
    }

    // obtem o maximo indice z
    var f_dhserver_zmax = function(elem) {
      var elems = document.getElementsByTagName(elem);
      var highest = 0;
      for (var i = 0; i < elems.length; i++)
      {
        var zindex=document.defaultView.getComputedStyle(elems[i],null).getPropertyValue("z-index");
        if ((zindex > highest) && (zindex != "auto"))
        {
          highest = zindex;
        }
      }
      return highest;
    };

    // retorna o escopo publico
    return publico;
}());

// execucoes
// // quando a pagina hml e carregada
window.addEventListener("load", dhserver.f_dhserver_iniciar());
// // quando uma mensagem e recebida (da iframe)
window.addEventListener('message', (event) => {
    dhserver.f_dhserver_receive_message(event);
});
